package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLBasicMap_userImport) ENABLED START ***/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLBasicMap extends JNIObject implements IISLSingleSpaceMapMethods, IISLProjectionMethods {
	
	/* @generated */
	protected ISLBasicMap(long ptr) {
		/*** PROTECTED REGION ID(ISLBasicMap_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLBasicMap build(long ptr) {
		return new ISLBasicMap(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLBasicMap_userCode) ENABLED START ***/
	public String toString(ISL_FORMAT format) {
		return ISLPrettyPrinter.asString(this, format);
	}
	
	public ISLBasicSet getDomain() {
		return copy().domain();
	}
	
	public ISLBasicSet getRange() {
		return copy().range();
	}
	
	public ISLBasicMap getDomainMap() {
		return copy().domainMap();
	}
	
	public ISLBasicMap getRangeMap() {
		return copy().rangeMap();
	}
	
	public List<ISLConstraint> getConstraints() {
		List<ISLConstraint> res = new ArrayList<ISLConstraint>();
		for (int i = 0; i < getNbConstraints(); i++) {
			res.add(this.getConstraintAt(i));
		}
		return res;
	}
	
	
	/***
	 * Converts ISLMap to ISLSet with equivalent constraints, but without the distinction of inputs/outputs.
	 * 
	 * @return
	 */
	public ISLBasicSet toBasicSet() {
		return this.moveDims(ISLDimType.isl_dim_in, getNbInputs(), ISLDimType.isl_dim_out, 0, getNbOutputs()).getDomain();
	}

	/**
	 * This method computes the closed form expressions of a relation. For
	 * example, given "{[i] -> [j] : 0 <= i < 8 && i = j + 8}", the result is a
	 * map with single entry containing the expression of "j" given "i" : "i-8",
	 * and its validity domain : "{[i] : 0 <= i < 8}". <br/>
	 * IMPORTANT : this methods compute the expressions using the lexmin
	 * algorithm. If the lexmax is expected, first apply the lexmax on the
	 * relation, and then call this method.
	 * 
	 * @return Map containing the closed form expressions of the relation, and
	 *         their associated validity domains.
	 */
	public Map<ISLSet, ISLMultiAff> getClosedFormRelation() {
		if (!isSingleValued())
			throw new RuntimeException(this + " is not single valued.");
		
		ISLPWMultiAff pwma = copy().lexMinAsPWMultiAff();
		
		Map<ISLMultiAff, ISLSet> tmp = new HashMap<ISLMultiAff, ISLSet>();
		main : for (ISLPWMultiAffPiece piece : pwma.getPieces()) {
			ISLSet validityDomain = piece.getSet();
			ISLMultiAff value = piece.getMaff();
			for (ISLMultiAff t : tmp.keySet())
			if (t.isPlainEqual(value)) {
				tmp.put(t, tmp.get(t).union(validityDomain));
				continue main;
			}
			tmp.put(value, validityDomain.coalesce());
		}
		
		Map<ISLSet, ISLMultiAff> res = new HashMap<ISLSet, ISLMultiAff>();
		for (Entry<ISLMultiAff, ISLSet> e : tmp.entrySet()) {
			res.put(e.getValue(), e.getKey());
		}
		return res;
	}
	
	/**
	 * Builds a shift relation.
	 * 
	 * @param setSpace space of the set on which the relation will be applied (in and out are equivalent)
	 * @param dim dimension that will be shifted
	 * @param size number of iterations to shift
	 * @return
	 */
	public static ISLBasicMap buildShift(ISLSpace setSpace, int dim, int size) {
		ISLBasicMap shift = ISLBasicMap.buildUniverse(ISLSpace
				.idMapDimFromSetDim(setSpace.copy()));
		long n = setSpace.dim(ISLDimType.isl_dim_set);
		for (int i = 0; i < n; i++) {
			ISLConstraint c = ISLConstraint.buildEquality(shift.getSpace().copy().toLocalSpace());
			c = c.setCoefficient(ISLDimType.isl_dim_in, i, 1);
			c = c.setCoefficient(ISLDimType.isl_dim_out, i, -1);
			if (i == dim)
				c = c.setConstant(size);
			shift = shift.addConstraint(c);
		}
		return shift;
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_basic_map_read_from_str 
	 * 
	 * @generated
	**/
	 public static ISLBasicMap buildFromString(ISLContext ctx, String str) { 
		/*** PROTECTED REGION ID(static_isl_basic_map_read_from_str) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_read_from_str(getNativePtr(ctx), str));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_empty 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLBasicMap buildEmpty(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_basic_map_empty) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_empty(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_universe 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLBasicMap buildUniverse(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_basic_map_universe) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_universe(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_nat_universe 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLBasicMap buildNonNegUniverse(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_basic_map_nat_universe) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_nat_universe(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_identity 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLBasicMap buildIdentity(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_basic_map_identity) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_identity(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_from_constraint_matrices 
	 * 
	@take space eq ineq
	 * @generated
	**/
	 public static ISLBasicMap fromConstraintMatrices(ISLSpace space, ISLMatrix eq, ISLMatrix ineq, ISLDimType c1, ISLDimType c2, ISLDimType c3, ISLDimType c4, ISLDimType c5) { 
		/*** PROTECTED REGION ID(static_isl_basic_map_from_constraint_matrices) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(space, eq, ineq);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_from_constraint_matrices(getNativePtr(space), getNativePtr(eq), getNativePtr(ineq), c1.getValue(), c2.getValue(), c3.getValue(), c4.getValue(), c5.getValue()));
			} finally {
				taken(space);
				taken(eq);
				taken(ineq);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLBasicMap bmap, int format) { 
		/*** PROTECTED REGION ID(static_isl_basic_map_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_to_string(getNativePtr(bmap), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_map_from_basic_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap toMap() {
		/*** PROTECTED REGION ID(isl_map_from_basic_map) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_from_basic_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_from_basic_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap toUnionMap() {
		/*** PROTECTED REGION ID(isl_union_map_from_basic_map) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_from_basic_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_basic_map_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_basic_map_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_basic_map_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_basic_map_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_copy 
	 * 
	 * @generated
	**/
	public ISLBasicMap copy() {
		/*** PROTECTED REGION ID(isl_basic_map_copy) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_basic_map_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_basic_map_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_add_constraint 
	 * 
	 * @take this constraint
	 * @generated
	**/
	public ISLBasicMap addConstraint(ISLConstraint constraint) {
		/*** PROTECTED REGION ID(isl_basic_map_add_constraint) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this, constraint);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_add_constraint(getNativePtr(this), getNativePtr(constraint)));
			} finally {
				taken(this);
				taken(constraint);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_dim 
	 * 
	 * @generated
	**/
	public int dim(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_basic_map_dim) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_dim(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_get_tuple_name 
	 * 
	 * @generated
	**/
	public String getTupleName(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_basic_map_get_tuple_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_get_tuple_name(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_set_tuple_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap setTupleName(ISLDimType type, String s) {
		/*** PROTECTED REGION ID(isl_basic_map_set_tuple_name) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_set_tuple_name(getNativePtr(this), type.getValue(), s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_get_dim_name 
	 * 
	 * @generated
	**/
	public String getDimName(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_basic_map_get_dim_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_get_dim_name(getNativePtr(this), type.getValue(), pos);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_set_dim_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap setDimName(ISLDimType type, int pos, String s) {
		/*** PROTECTED REGION ID(isl_basic_map_set_dim_name) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_set_dim_name(getNativePtr(this), type.getValue(), pos, s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_involves_dims 
	 * 
	 * @generated
	**/
	public boolean involvesDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_basic_map_involves_dims) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_involves_dims(getNativePtr(this), type.getValue(), first, n) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_has_dim_id 
	 * 
	 * @generated
	**/
	public boolean hasDimID(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_basic_map_has_dim_id) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_has_dim_id(getNativePtr(this), type.getValue(), pos) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_remove_divs 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap removeDivs() {
		/*** PROTECTED REGION ID(isl_basic_map_remove_divs) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_remove_divs(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_remove_divs_involving_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap removeDivsInvolvingDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_basic_map_remove_divs_involving_dims) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_remove_divs_involving_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_equalities_matrix 
	 * 
	 * @generated
	**/
	public ISLMatrix getEqualityMatrix(ISLDimType c1, ISLDimType c2, ISLDimType c3, ISLDimType c4, ISLDimType c5) {
		/*** PROTECTED REGION ID(isl_basic_map_equalities_matrix) DISABLED START ***/
		ISLMatrix res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMatrix.build(ISLNative.isl_basic_map_equalities_matrix(getNativePtr(this), c1.getValue(), c2.getValue(), c3.getValue(), c4.getValue(), c5.getValue()));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_inequalities_matrix 
	 * 
	 * @generated
	**/
	public ISLMatrix getInequalityMatrix(ISLDimType c1, ISLDimType c2, ISLDimType c3, ISLDimType c4, ISLDimType c5) {
		/*** PROTECTED REGION ID(isl_basic_map_inequalities_matrix) DISABLED START ***/
		ISLMatrix res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMatrix.build(ISLNative.isl_basic_map_inequalities_matrix(getNativePtr(this), c1.getValue(), c2.getValue(), c3.getValue(), c4.getValue(), c5.getValue()));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_plain_is_empty 
	 * 
	 * @generated
	**/
	public boolean isPlainEmpty() {
		/*** PROTECTED REGION ID(isl_basic_map_plain_is_empty) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_plain_is_empty(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_is_empty 
	 * 
	 * @generated
	**/
	public boolean isEmpty() {
		/*** PROTECTED REGION ID(isl_basic_map_is_empty) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_is_empty(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_is_universe 
	 * 
	 * @generated
	**/
	public boolean isUniverse() {
		/*** PROTECTED REGION ID(isl_basic_map_is_universe) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_is_universe(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_is_single_valued 
	 * 
	 * @generated
	**/
	public boolean isSingleValued() {
		/*** PROTECTED REGION ID(isl_basic_map_is_single_valued) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_is_single_valued(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_can_curry 
	 * 
	 * @generated
	**/
	public boolean canCurry() {
		/*** PROTECTED REGION ID(isl_basic_map_can_curry) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_can_curry(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_can_uncurry 
	 * 
	 * @generated
	**/
	public boolean canUncurry() {
		/*** PROTECTED REGION ID(isl_basic_map_can_uncurry) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_can_uncurry(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_can_zip 
	 * 
	 * @generated
	**/
	public boolean canZip() {
		/*** PROTECTED REGION ID(isl_basic_map_can_zip) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_can_zip(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_is_equal 
	 * 
	 * @generated
	**/
	public boolean isEqual(ISLBasicMap bmap2) {
		/*** PROTECTED REGION ID(isl_basic_map_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_is_equal(getNativePtr(this), getNativePtr(bmap2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_is_disjoint 
	 * 
	 * @generated
	**/
	public boolean isDisjoint(ISLBasicMap bmap2) {
		/*** PROTECTED REGION ID(isl_basic_map_is_disjoint) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_is_disjoint(getNativePtr(this), getNativePtr(bmap2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_is_subset 
	 * 
	 * @generated
	**/
	public boolean isSubset(ISLBasicMap bmap2) {
		/*** PROTECTED REGION ID(isl_basic_map_is_subset) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_is_subset(getNativePtr(this), getNativePtr(bmap2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_is_strict_subset 
	 * 
	 * @generated
	**/
	public boolean isStrictSubset(ISLBasicMap bmap2) {
		/*** PROTECTED REGION ID(isl_basic_map_is_strict_subset) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_is_strict_subset(getNativePtr(this), getNativePtr(bmap2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_reverse 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap reverse() {
		/*** PROTECTED REGION ID(isl_basic_map_reverse) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_reverse(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_project_out 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap projectOut(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_basic_map_project_out) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_project_out(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet domain() {
		/*** PROTECTED REGION ID(isl_basic_map_domain) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_map_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_range 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet range() {
		/*** PROTECTED REGION ID(isl_basic_map_range) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_map_range(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_domain_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap domainMap() {
		/*** PROTECTED REGION ID(isl_basic_map_domain_map) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_domain_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_range_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap rangeMap() {
		/*** PROTECTED REGION ID(isl_basic_map_range_map) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_range_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_eliminate 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap eliminate(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_basic_map_eliminate) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_eliminate(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_fix_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap sliceFixed(ISLDimType type, int pos, int value) {
		/*** PROTECTED REGION ID(isl_basic_map_fix_si) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_fix_si(getNativePtr(this), type.getValue(), pos, value));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_fix_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLBasicMap sliceFixed(ISLDimType type, int pos, ISLVal v) {
		/*** PROTECTED REGION ID(isl_basic_map_fix_val) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_fix_val(getNativePtr(this), type.getValue(), pos, getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_lower_bound_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap sliceLB(ISLDimType type, int pos, int value) {
		/*** PROTECTED REGION ID(isl_basic_map_lower_bound_si) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_lower_bound_si(getNativePtr(this), type.getValue(), pos, value));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_upper_bound_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap sliceUB(ISLDimType type, int pos, int value) {
		/*** PROTECTED REGION ID(isl_basic_map_upper_bound_si) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_upper_bound_si(getNativePtr(this), type.getValue(), pos, value));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_equate 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap sliceEquate(ISLDimType type1, int pos1, ISLDimType type2, int pos2) {
		/*** PROTECTED REGION ID(isl_basic_map_equate) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_equate(getNativePtr(this), type1.getValue(), pos1, type2.getValue(), pos2));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_order_ge 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap sliceGE(ISLDimType type1, int pos1, ISLDimType type2, int pos2) {
		/*** PROTECTED REGION ID(isl_basic_map_order_ge) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_order_ge(getNativePtr(this), type1.getValue(), pos1, type2.getValue(), pos2));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_order_gt 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap sliceGT(ISLDimType type1, int pos1, ISLDimType type2, int pos2) {
		/*** PROTECTED REGION ID(isl_basic_map_order_gt) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_order_gt(getNativePtr(this), type1.getValue(), pos1, type2.getValue(), pos2));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_deltas 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet deltas() {
		/*** PROTECTED REGION ID(isl_basic_map_deltas) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_map_deltas(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_deltas_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap deltasMap() {
		/*** PROTECTED REGION ID(isl_basic_map_deltas_map) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_deltas_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_detect_equalities 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap detectEqualities() {
		/*** PROTECTED REGION ID(isl_basic_map_detect_equalities) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_detect_equalities(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_remove_redundancies 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap removeRedundancies() {
		/*** PROTECTED REGION ID(isl_basic_map_remove_redundancies) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_remove_redundancies(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_affine_hull 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap affineHull() {
		/*** PROTECTED REGION ID(isl_basic_map_affine_hull) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_affine_hull(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_drop_constraints_involving_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap dropConstraintsInvolvingDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_basic_map_drop_constraints_involving_dims) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_drop_constraints_involving_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_sample 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap sample() {
		/*** PROTECTED REGION ID(isl_basic_map_sample) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_sample(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_wrap 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet wrap() {
		/*** PROTECTED REGION ID(isl_basic_map_wrap) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_map_wrap(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_flatten 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap flatten() {
		/*** PROTECTED REGION ID(isl_basic_map_flatten) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_flatten(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_flatten_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap flattenDomain() {
		/*** PROTECTED REGION ID(isl_basic_map_flatten_domain) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_flatten_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_flatten_range 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap flattenRange() {
		/*** PROTECTED REGION ID(isl_basic_map_flatten_range) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_flatten_range(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_zip 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap zip() {
		/*** PROTECTED REGION ID(isl_basic_map_zip) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_zip(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_curry 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap curry() {
		/*** PROTECTED REGION ID(isl_basic_map_curry) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_curry(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_uncurry 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap uncurry() {
		/*** PROTECTED REGION ID(isl_basic_map_uncurry) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_uncurry(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_align_params 
	 * 
	 * @take this model
	 * @generated
	**/
	public ISLBasicMap alignParams(ISLSpace model) {
		/*** PROTECTED REGION ID(isl_basic_map_align_params) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this, model);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_align_params(getNativePtr(this), getNativePtr(model)));
			} finally {
				taken(this);
				taken(model);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_add_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap addDims(ISLDimType type, int n) {
		/*** PROTECTED REGION ID(isl_basic_map_add_dims) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_add_dims(getNativePtr(this), type.getValue(), n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_insert_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap insertDims(ISLDimType type, int pos, int n) {
		/*** PROTECTED REGION ID(isl_basic_map_insert_dims) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_insert_dims(getNativePtr(this), type.getValue(), pos, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_move_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap moveDims(ISLDimType dst_type, int dst_pos, ISLDimType src_type, int src_pos, int n) {
		/*** PROTECTED REGION ID(isl_basic_map_move_dims) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_move_dims(getNativePtr(this), dst_type.getValue(), dst_pos, src_type.getValue(), src_pos, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_intersect_domain 
	 * 
	 * @take this bset
	 * @generated
	**/
	public ISLBasicMap intersectDomain(ISLBasicSet bset) {
		/*** PROTECTED REGION ID(isl_basic_map_intersect_domain) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this, bset);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_intersect_domain(getNativePtr(this), getNativePtr(bset)));
			} finally {
				taken(this);
				taken(bset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_intersect_range 
	 * 
	 * @take this bset
	 * @generated
	**/
	public ISLBasicMap intersectRange(ISLBasicSet bset) {
		/*** PROTECTED REGION ID(isl_basic_map_intersect_range) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this, bset);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_intersect_range(getNativePtr(this), getNativePtr(bset)));
			} finally {
				taken(this);
				taken(bset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_intersect 
	 * 
	 * @take this bmap2
	 * @generated
	**/
	public ISLBasicMap intersect(ISLBasicMap bmap2) {
		/*** PROTECTED REGION ID(isl_basic_map_intersect) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this, bmap2);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_intersect(getNativePtr(this), getNativePtr(bmap2)));
			} finally {
				taken(this);
				taken(bmap2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_union 
	 * 
	 * @take this bmap2
	 * @generated
	**/
	public ISLMap union(ISLBasicMap bmap2) {
		/*** PROTECTED REGION ID(isl_basic_map_union) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, bmap2);
			try {
				res = ISLMap.build(ISLNative.isl_basic_map_union(getNativePtr(this), getNativePtr(bmap2)));
			} finally {
				taken(this);
				taken(bmap2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_apply_domain 
	 * 
	 * @take this bmap2
	 * @generated
	**/
	public ISLBasicMap applyDomain(ISLBasicMap bmap2) {
		/*** PROTECTED REGION ID(isl_basic_map_apply_domain) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this, bmap2);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_apply_domain(getNativePtr(this), getNativePtr(bmap2)));
			} finally {
				taken(this);
				taken(bmap2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_apply_range 
	 * 
	 * @take this bmap2
	 * @generated
	**/
	public ISLBasicMap applyRange(ISLBasicMap bmap2) {
		/*** PROTECTED REGION ID(isl_basic_map_apply_range) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this, bmap2);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_apply_range(getNativePtr(this), getNativePtr(bmap2)));
			} finally {
				taken(this);
				taken(bmap2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_preimage_domain_multi_aff 
	 * 
	 * @take this ma
	 * @generated
	**/
	public ISLBasicMap preimageDomain(ISLMultiAff ma) {
		/*** PROTECTED REGION ID(isl_basic_map_preimage_domain_multi_aff) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this, ma);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_preimage_domain_multi_aff(getNativePtr(this), getNativePtr(ma)));
			} finally {
				taken(this);
				taken(ma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_preimage_range_multi_aff 
	 * 
	 * @take this ma
	 * @generated
	**/
	public ISLBasicMap preimageRange(ISLMultiAff ma) {
		/*** PROTECTED REGION ID(isl_basic_map_preimage_range_multi_aff) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this, ma);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_preimage_range_multi_aff(getNativePtr(this), getNativePtr(ma)));
			} finally {
				taken(this);
				taken(ma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_gist 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLBasicMap gist(ISLBasicMap context) {
		/*** PROTECTED REGION ID(isl_basic_map_gist) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_gist(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_partial_lexmin 
	 * 
	 * @take this dom
	 * @generated
	**/
	public ISLMap partialLexMin(ISLBasicSet dom) {
		/*** PROTECTED REGION ID(isl_basic_map_partial_lexmin) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, dom);
			try {
				res = ISLMap.build(ISLNative.isl_basic_map_partial_lexmin(getNativePtr(this), getNativePtr(dom)));
			} finally {
				taken(this);
				taken(dom);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_partial_lexmax 
	 * 
	 * @take this dom
	 * @generated
	**/
	public ISLMap partialLexMax(ISLBasicSet dom) {
		/*** PROTECTED REGION ID(isl_basic_map_partial_lexmax) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this, dom);
			try {
				res = ISLMap.build(ISLNative.isl_basic_map_partial_lexmax(getNativePtr(this), getNativePtr(dom)));
			} finally {
				taken(this);
				taken(dom);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_lexmin 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap lexMin() {
		/*** PROTECTED REGION ID(isl_basic_map_lexmin) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_basic_map_lexmin(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_lexmax 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap lexMax() {
		/*** PROTECTED REGION ID(isl_basic_map_lexmax) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_basic_map_lexmax(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_lexmin_pw_multi_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPWMultiAff lexMinAsPWMultiAff() {
		/*** PROTECTED REGION ID(isl_basic_map_lexmin_pw_multi_aff) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_basic_map_lexmin_pw_multi_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_partial_lexmin_pw_multi_aff 
	 * 
	 * @take this dom
	 * @generated
	**/
	public ISLPWMultiAff partialLexMinAsPWMultiAff(ISLBasicSet dom) {
		/*** PROTECTED REGION ID(isl_basic_map_partial_lexmin_pw_multi_aff) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, dom);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_basic_map_partial_lexmin_pw_multi_aff(getNativePtr(this), getNativePtr(dom)));
			} finally {
				taken(this);
				taken(dom);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_partial_lexmax_pw_multi_aff 
	 * 
	 * @take this dom
	 * @generated
	**/
	public ISLPWMultiAff partialLexMaxAsPWMultiAff(ISLBasicSet dom) {
		/*** PROTECTED REGION ID(isl_basic_map_partial_lexmax_pw_multi_aff) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, dom);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_basic_map_partial_lexmax_pw_multi_aff(getNativePtr(this), getNativePtr(dom)));
			} finally {
				taken(this);
				taken(dom);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_numberof_constraint 
	 * 
	 * @generated
	**/
	public int getNbConstraints() {
		/*** PROTECTED REGION ID(isl_basic_map_numberof_constraint) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_map_numberof_constraint(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_map_get_constraint_at 
	 * 
	 * @generated
	**/
	public ISLConstraint getConstraintAt(int pos) {
		/*** PROTECTED REGION ID(isl_basic_map_get_constraint_at) DISABLED START ***/
		ISLConstraint res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLConstraint.build(ISLNative.isl_basic_map_get_constraint_at(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLBasicMap_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
